import e32
import graphics

import wu_parser

# config
# location= "tampere, finland"
# update_cycle = 3 hours # about 10 kb data per update


# possibile outputs:
# - data parsed correctly
# - data parsing failed
# - could not connect
# in all cases -> schedule update normally

# (all plugins, how to report errors?)

# last update: xx:xx


# temp, humidity, wind, preasure
# graphic (when switch to night/day?)
# forecast:
# graphic, temp
#
class WeatherPlugin:
    y_size = 100
    ICON_PATH = "C:\\temp\\pics\\%d.gif"
    def __init__(self, config):
        self.config = config
        self.img = graphics.Image.new((self.config.x_size, self.y_size))
        e32.ao_sleep(0, self._update)
        
    def render_screen(self, bitmap, target_coords):
        #print "rendering", bitmap, target_coords
        bitmap.blit(self.img, target_coords)

    def _update(self):
        try:
            self._do_update()
        finally:
            e32.ao_sleep(self.config.interval, self._update)

    def _do_update(self):
        info = wu.get_weather_info(self.config.station, self.config.iap)
        
        fname = self.ICON_PATH % int(info['current'][1])
        cur_pic = graphics.Image.open(fname)
        self.img.blit(cur_pic, target=(0, 0), source=(0, 4))

        # forecast pics
        x_offset = 52
        for i in range(3):
            fname = self.ICON_PATH % int(info['forecast+%dd' % i][5])
            cur_pic = graphics.Image.open(fname)
            cur_pic = cur_pic.resize((41, 41))
            self.img.blit(cur_pic, target=(x_offset, 0), source=(0, 0))
            x_offset += 41

        y_offset = 57
        #self.img.text((0, offset), unicode(info['city']))        
        firstline = "%s: %s, %s%s" % (unicode(info['timestamp']), 
                                      unicode(info['current'][0]), 
                                      unicode(info['current'][2]),
                                      unicode(info['unit']))
        
        self.img.text((2, y_offset), firstline)

        for i in range(3):
            f = info['forecast+%dd' % i]
            fields = (f[0], f[4], f[2], f[3], info['unit'])
            txt = "%s: %s, %s-%s%s" % tuple(map(unicode, fields))
            y_offset += 14
            self.img.text((2, y_offset), txt)

    
def init_plugin(config):
  # here perform other setup code
  weather_plugin = WeatherPlugin(config)
  return weather_plugin.render_screen, weather_plugin.y_size


