import BeautifulSoup
import time
import re

TESTING = 0
try:
    import iapconnect # only works in s60/python
except:
    TESTING = 1

def fetch_weather_data(default_iap, station):
    addr = "xml.weather.yahoo.com"
    path = "/forecastrss?p=%s&u=c" % station
    c = iapconnect.Connection()
    try:
        c.connect(addr, 80, default_iap)
        c.send("GET %s HTTP/1.0" % path)
        buf = []
        while 1:
            data = conn.recv(4*1024)
            if not data:
                break
            buf.append(data)
            
        buf = ''.join(buf)
        return buf
    finally:
        conn.stop()
    

if TESTING:
    def fetch_weather_data(default_iap, station):
        return open("forecastrss.xml").read()

def parse_weather_data(data):
    info = {}
    soup = BeautifulSoup.BeautifulSoup(data)

    # timestamp (extract HH:MM <am/pm>)
    ts = ' '.join(soup.first("pubdate").string.split()[4:6])
    info['timestamp'] = ts
    loc = soup.first("yweather:location")
    info['city'] = loc.attrs[0][1]
    info['country'] = loc.attrs[2][1]
    info['unit'] = soup.first("yweather:units").attrs[0][1]
    #soup.first("yweather:location")
    #Current Conditions:
    lines = soup.rss.channel.item.description.string.split("\n")
    lines = [lines[4]] + lines[7:9] # today + two day forecast
    formatted = []
    for line in lines:
        formatted.append(line[:line.index("<")].strip())

    info['cur'] = formatted[0]
    info['forecast'] = formatted[1:]

    return info

def get_weather_info(default_iap, station):
    return parse_weather_data(fetch_weather_data(default_iap, station))
    
if __name__ == "__main__":
    print get_weather_info(0, 0)


