#include <e32std.h>
#include <e32base.h>

#include <AknUtils.h>

#include "Python.h"
#include "symbian_python_ext_util.h"



static PyObject* akntextutils_wrap_text_to_array(PyObject* /*self*/, PyObject *args)
{
  char* text_ = 0;	
  TInt textlen = 0;
  char* font_ = 0;
  
  TInt width = 0;
  const CFont* font = 0;
  
  if (!PyArg_ParseTuple(args, "u#si", &text_, &textlen, &font_, &width))
  {
    return 0;
  }

  TPtrC text((TUint16*)text_, textlen);

  if (!strcmp("annotation", font_))
  {
    font = CEikonEnv::Static()->AnnotationFont();
  }
  else if (!strcmp("title", font_))
  {
    font = CEikonEnv::Static()->TitleFont();
  }
  else if (!strcmp("legend", font_))
  {
    font = CEikonEnv::Static()->LegendFont();
  }
  else if (!strcmp("symbol", font_))
  {
    font = CEikonEnv::Static()->SymbolFont();
  }
  else if (!strcmp("dense", font_))
  {
    font = CEikonEnv::Static()->DenseFont();
  }
  else // normal
  {
    font = CEikonEnv::Static()->NormalFont();
  }

  CArrayFix<TPtrC>* target = new (ELeave) CArrayFixFlat<TPtrC>(5);
  TRAPD(err,
        AknTextUtils::WrapToArrayL(text, width, *font, *target);
        );
  
  if (err)
  {
    delete target;
	return SPyErr_SetFromSymbianOSErr(err);
  }

  PyObject *tuple;
  tuple = PyTuple_New(target->Count());

  for (TInt i = 0; i < target->Count(); i++)
  {
    PyObject *str = Py_BuildValue("u#", (*target)[i].Ptr(), (*target)[i].Length());        
    PyTuple_SET_ITEM(tuple, i, str);
  }
    
  delete target;
  return tuple;
}


static const PyMethodDef akntextutils_methods[] =
{
	{"wrap_text_to_array", (PyCFunction)akntextutils_wrap_text_to_array, METH_VARARGS},		
	{0, 0} /* sentinel */
};

DL_EXPORT(void) init_iapconnect()
{
	PyObject* module = Py_InitModule("akntextutils",
                                   (PyMethodDef*) akntextutils_methods);
}

GLDEF_C TInt E32Dll(TDllReason)
{
	return KErrNone;
}


