#ifndef CONNMANAGER_H
#define CONNMANAGER_H

#include <e32base.h>
#include <CommDbConnPref.h>
#include <es_sock.h>
#include <in_sock.h>


#include "TimeoutTimer.h"
#include "Timeoutnotifier.h"

class CConnManager : public CActive, public MTimeOutNotifier
{
public:
	static CConnManager* NewL();	
	
	static TInt SelectIAPL();
  
	void ConnectL(const TDesC& aAddr, TInt aPort, TInt iAIP);
	void SoftCloseL();
	void HardCloseL();

	void RecvL(TDes8& aBuffer, TInt aTimeout);
	void SendL(const TDesC8& aBuffer, TInt aTimeout);

	~CConnManager();

public: // from MTimeOutNotifier
	void TimerExpired();

protected:
	CConnManager();	
	void ConstructL();

	void RunL();
	void DoCancel();

private:
  RSocketServ iSocketServ;
  RConnection iConnection;
  RHostResolver iResolver;
  RSocket iSock;

  TInetAddr iDestAddr;
  CActiveSchedulerWait* iWaitLoop;

  TSockXfrLength iXfrLength;

  CTimeOutTimer* iTimer;
};

#endif
