/* Copyright (c) 2003, Nokia. All rights reserved */

#ifndef __HELLOWORLDBASIC_APPUI_H__
#define __HELLOWORLDBASIC_APPUI_H__

#include <aknappui.h>



/*! 
  @class CHelloWorldBasicAppUi
  
  @discussion An instance of class CHelloWorldBasicAppUi is the UserInterface part of the AVKON
  application framework for the HelloWorldBasic example application
  */
class CHelloWorldBasicAppUi : public CAknAppUi
    {
public:
/*!
  @function ConstructL
  
  @discussion Perform the second phase construction of a CHelloWorldBasicAppUi object.
  This needs to be public due to the way the framework constructs the AppUi 
  */
    void ConstructL();

/*!
  @function CHelloWorldBasicAppUi
  
  @discussion Perform the first phase of two phase construction.
  This needs to be public due to the way the framework constructs the AppUi 
  */
    CHelloWorldBasicAppUi();


/*!
  @function ~CHelloWorldBasicAppUi
  
  @discussion Destroy the object
  */
    ~CHelloWorldBasicAppUi();


public: // from CAknAppUi
/*!
  @function HandleCommandL
  
  @discussion Handle user menu selections
  @param aCommand The enumerated code for the option selected
  */
    void HandleCommandL(TInt aCommand);

private:
	void SendPacketL();
    };


#endif // __HELLOWORLDBASIC_APPUI_H__

