/* Copyright (c) 2003, Nokia. All rights reserved */

#include "HelloWorldBasicAppUi.h"
#include "HelloWorldBasicDocument.h"

CHelloWorldBasicDocument* CHelloWorldBasicDocument::NewL(CEikApplication& aApp)
    {
    CHelloWorldBasicDocument* self = NewLC(aApp);
    CleanupStack::Pop(self);
    return self;
    }

CHelloWorldBasicDocument* CHelloWorldBasicDocument::NewLC(CEikApplication& aApp)
    {
    CHelloWorldBasicDocument* self = new (ELeave) CHelloWorldBasicDocument(aApp);
    CleanupStack::PushL(self);
    self->ConstructL();
    return self;
    }

void CHelloWorldBasicDocument::ConstructL()
    {
	// No implementation required
    }    

CHelloWorldBasicDocument::CHelloWorldBasicDocument(CEikApplication& aApp) : CAknDocument(aApp) 
    {
	// No implementation required
    }

CHelloWorldBasicDocument::~CHelloWorldBasicDocument()
    {
	// No implementation required
    }

CEikAppUi* CHelloWorldBasicDocument::CreateAppUiL()
    {
    // Create the application user interface, and return a pointer to it;
    // the framework takes ownership of this object
	return (static_cast <CEikAppUi*> (new (ELeave) CHelloWorldBasicAppUi)); 
    }

